// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from grbl_msgs:action/SendGcodeCmd.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__STRUCT_H_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'command'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_Goal
{
  rosidl_runtime_c__String command;
} grbl_msgs__action__SendGcodeCmd_Goal;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_Goal.
typedef struct grbl_msgs__action__SendGcodeCmd_Goal__Sequence
{
  grbl_msgs__action__SendGcodeCmd_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_Result
{
  bool success;
} grbl_msgs__action__SendGcodeCmd_Result;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_Result.
typedef struct grbl_msgs__action__SendGcodeCmd_Result__Sequence
{
  grbl_msgs__action__SendGcodeCmd_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'status'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_Feedback
{
  rosidl_runtime_c__String status;
} grbl_msgs__action__SendGcodeCmd_Feedback;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_Feedback.
typedef struct grbl_msgs__action__SendGcodeCmd_Feedback__Sequence
{
  grbl_msgs__action__SendGcodeCmd_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "grbl_msgs/action/detail/send_gcode_cmd__struct.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  grbl_msgs__action__SendGcodeCmd_Goal goal;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Request;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_SendGoal_Request.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence
{
  grbl_msgs__action__SendGcodeCmd_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Response;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_SendGoal_Response.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence
{
  grbl_msgs__action__SendGcodeCmd_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  grbl_msgs__action__SendGcodeCmd_SendGoal_Event__request__MAX_SIZE = 1
};
// response
enum
{
  grbl_msgs__action__SendGcodeCmd_SendGoal_Event__response__MAX_SIZE = 1
};

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Event
{
  service_msgs__msg__ServiceEventInfo info;
  grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence request;
  grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence response;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Event;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_SendGoal_Event.
typedef struct grbl_msgs__action__SendGcodeCmd_SendGoal_Event__Sequence
{
  grbl_msgs__action__SendGcodeCmd_SendGoal_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_SendGoal_Event__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} grbl_msgs__action__SendGcodeCmd_GetResult_Request;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_GetResult_Request.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence
{
  grbl_msgs__action__SendGcodeCmd_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_cmd__struct.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Response
{
  int8_t status;
  grbl_msgs__action__SendGcodeCmd_Result result;
} grbl_msgs__action__SendGcodeCmd_GetResult_Response;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_GetResult_Response.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence
{
  grbl_msgs__action__SendGcodeCmd_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  grbl_msgs__action__SendGcodeCmd_GetResult_Event__request__MAX_SIZE = 1
};
// response
enum
{
  grbl_msgs__action__SendGcodeCmd_GetResult_Event__response__MAX_SIZE = 1
};

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Event
{
  service_msgs__msg__ServiceEventInfo info;
  grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence request;
  grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence response;
} grbl_msgs__action__SendGcodeCmd_GetResult_Event;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_GetResult_Event.
typedef struct grbl_msgs__action__SendGcodeCmd_GetResult_Event__Sequence
{
  grbl_msgs__action__SendGcodeCmd_GetResult_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_GetResult_Event__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_cmd__struct.h"

/// Struct defined in action/SendGcodeCmd in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeCmd_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  grbl_msgs__action__SendGcodeCmd_Feedback feedback;
} grbl_msgs__action__SendGcodeCmd_FeedbackMessage;

// Struct for a sequence of grbl_msgs__action__SendGcodeCmd_FeedbackMessage.
typedef struct grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence
{
  grbl_msgs__action__SendGcodeCmd_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__STRUCT_H_
