// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from grbl_msgs:srv/Stop.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__SRV__DETAIL__STOP__STRUCT_HPP_
#define GRBL_MSGS__SRV__DETAIL__STOP__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__grbl_msgs__srv__Stop_Request __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__srv__Stop_Request __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Stop_Request_
{
  using Type = Stop_Request_<ContainerAllocator>;

  explicit Stop_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->machine_id = "";
      this->command = "";
    }
  }

  explicit Stop_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : machine_id(_alloc),
    command(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->machine_id = "";
      this->command = "";
    }
  }

  // field types and members
  using _machine_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _machine_id_type machine_id;
  using _command_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _command_type command;

  // setters for named parameter idiom
  Type & set__machine_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->machine_id = _arg;
    return *this;
  }
  Type & set__command(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->command = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::srv::Stop_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::srv::Stop_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__srv__Stop_Request
    std::shared_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__srv__Stop_Request
    std::shared_ptr<grbl_msgs::srv::Stop_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Stop_Request_ & other) const
  {
    if (this->machine_id != other.machine_id) {
      return false;
    }
    if (this->command != other.command) {
      return false;
    }
    return true;
  }
  bool operator!=(const Stop_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Stop_Request_

// alias to use template instance with default allocator
using Stop_Request =
  grbl_msgs::srv::Stop_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace grbl_msgs


#ifndef _WIN32
# define DEPRECATED__grbl_msgs__srv__Stop_Response __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__srv__Stop_Response __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Stop_Response_
{
  using Type = Stop_Response_<ContainerAllocator>;

  explicit Stop_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit Stop_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::srv::Stop_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::srv::Stop_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__srv__Stop_Response
    std::shared_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__srv__Stop_Response
    std::shared_ptr<grbl_msgs::srv::Stop_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Stop_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const Stop_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Stop_Response_

// alias to use template instance with default allocator
using Stop_Response =
  grbl_msgs::srv::Stop_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace grbl_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__grbl_msgs__srv__Stop_Event __attribute__((deprecated))
#else
# define DEPRECATED__grbl_msgs__srv__Stop_Event __declspec(deprecated)
#endif

namespace grbl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Stop_Event_
{
  using Type = Stop_Event_<ContainerAllocator>;

  explicit Stop_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit Stop_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<grbl_msgs::srv::Stop_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<grbl_msgs::srv::Stop_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<grbl_msgs::srv::Stop_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<grbl_msgs::srv::Stop_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<grbl_msgs::srv::Stop_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<grbl_msgs::srv::Stop_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<grbl_msgs::srv::Stop_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<grbl_msgs::srv::Stop_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    grbl_msgs::srv::Stop_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const grbl_msgs::srv::Stop_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      grbl_msgs::srv::Stop_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__grbl_msgs__srv__Stop_Event
    std::shared_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__grbl_msgs__srv__Stop_Event
    std::shared_ptr<grbl_msgs::srv::Stop_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Stop_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const Stop_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Stop_Event_

// alias to use template instance with default allocator
using Stop_Event =
  grbl_msgs::srv::Stop_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace grbl_msgs

namespace grbl_msgs
{

namespace srv
{

struct Stop
{
  using Request = grbl_msgs::srv::Stop_Request;
  using Response = grbl_msgs::srv::Stop_Response;
  using Event = grbl_msgs::srv::Stop_Event;
};

}  // namespace srv

}  // namespace grbl_msgs

#endif  // GRBL_MSGS__SRV__DETAIL__STOP__STRUCT_HPP_
